#include<bits/stdc++.h>
using namespace std;
int mas[2001];
int dp[20001];
int main(){
    int N,S;
    cin>>S;
    cin>>N;
    for(int i=0;i<N;i++){
        cin>>mas[i];
    }
    for(int i=0;i<S;i++){
        for(int j=0;j<N;j++){
            if(!dp[i+mas[j]]){
                dp[i+mas[j]]=dp[i]+1;
            }else{
                dp[i+mas[j]]=min(dp[i+mas[j]],dp[i]+1);
            }
        }
    }
    cout<<dp[S]<<endl;
    return 0;
}
